﻿# -*- coding: utf-8 -*-
import xbmcplugin
import xbmcgui
import sys
import urllib, urllib2
import time
import re
from htmlentitydefs import name2codepoint as n2cp

thisPlugin = int(sys.argv[1])

urlHost = "http://www.sublvl.com"
ajaxUrl = "http://www.sublvl.com/wp-content/themes/sl/get-track.php?track_id="

# -----regexFindTracks-------
# input - host or /popular-posts/
# matches
# [0] project link
# [1] track id
# [2] data-nonce 
# [3] picture-url
# [4] title
regexFindTracks = 'class="project-link" href="([^"]+)" data-post_id="([^"]+)" data-nonce="([^"]+)"> <img.*?src="(.*?)&amp;(.*?)" alt="([^"]+)"'
# 
# -----regexFindAudioUrl--------
# input - www.sublvl.com/wp-content/themes/sl/get-track.php?track_id=<track id>-0
# matches
# [0] audio url
regexAudioUrl = '"url":"([^"]+)"'

# -----regexFindStreamTracks-------
# input - /stream/
# matches
# [0] pic url
# [1] track id
# [2] artist 
# [3] title
regexFindStreamTracks = 'player-left"> <img.*?src="([\S]+).*?id="title([-0-9]+).*?artist">(.*?)</span> - (.*?) <span'
# ------------------------

def showContent():
	global thisPlugin

	try:
		content = getUrl(urlHost)
		addDirectoryItem("Latest Tracks",{"urlL":urlHost});
		addDirectoryItem("Popular Tracks",{"urlP":urlHost+"/popular-posts/"});
		addDirectoryItem("Daily Stream Collection",{"urlS":urlHost+"/stream/"});
	except Exception:
		addDirectoryItem("no Connection!",{});
		print "--sublvl-- showContent no connection"	
	print "--- showContent ok"	
	xbmcplugin.endOfDirectory(thisPlugin)

def playLatest(urlL):
	global thisPlugin
	print urlL
	content = getUrl(urlL)
	#print content
	foundTracks = re.compile(regexFindTracks,re.DOTALL).findall(content)
	#print foundTracks
	for f in foundTracks:
		print f
		streamUrl=""
		streamData = getUrl(ajaxUrl+f[1]+"-0")
		foundUrl = re.compile(regexAudioUrl,re.DOTALL).findall(streamData)
		streamUrl= foundUrl[0].replace('\\','')
		artist = unescape(f[5].decode("utf-8").replace('&#8211;',' | '))
		print "--sublvl-- foundUrl : "+streamUrl
		if len(streamUrl) > 50:
			addPlayableItem(artist, streamUrl, f[3]+"&amp;h=256&amp;w=256&amp;q=80")
	print "--- playLatest ok"	
	xbmcplugin.endOfDirectory(thisPlugin)

def playPopular(urlP):
	global thisPlugin
	print urlP
	content = getUrl(urlP)
	#print content
	foundTracks = re.compile(regexFindTracks,re.DOTALL).findall(content)
	#print foundTracks
	for f in foundTracks:
		print f
		streamData = getUrl(ajaxUrl+f[1]+"-0")
		foundUrl = re.compile(regexAudioUrl,re.DOTALL).findall(streamData)
		print "--sublvl-- foundUrl"
		streamUrl= foundUrl[0].replace('\\','')
		artist = unescape(f[5].decode("utf-8").replace('&#8211;',' | '))
		print "--sublvl-- foundUrl : "+streamUrl
		addPlayableItem(artist, streamUrl, f[3]+"&amp;h=256&amp;w=256&amp;q=80")
	print "--- playPopular ok"	
	xbmcplugin.endOfDirectory(thisPlugin)

def playStream(urlS):
	global thisPlugin
	print urlS
	content = getUrl(urlS)
	#print content
	foundTracks = re.compile(regexFindStreamTracks,re.DOTALL).findall(content)
	#print foundTracks
	for f in foundTracks:
		print f
		streamData = getUrl(ajaxUrl+f[1])
		foundUrl = re.compile(regexAudioUrl,re.DOTALL).findall(streamData)
		print "--sublvl-- foundUrl"
		streamUrl= foundUrl[0].replace('\\','')
		artist = unescape(f[2].decode("utf-8").replace('&#8211;',' | '))
		title = unescape(f[3].decode("utf-8").replace('&#8211;',' | '))
		print "--sublvl-- foundUrl : "+streamUrl
		addPlayableItem(artist+" | "+title, streamUrl, f[0])
	print "--- playPopular ok"	
	xbmcplugin.endOfDirectory(thisPlugin)	
# ------ helper ------

def remHTML(text):
	result = re.compile(regexTextOnly,re.DOTALL).sub('',text)
	return result

def postUrl(url, values):
    req = urllib2.Request(url)
    response = urllib2.urlopen(req, values)
    link=response.read()
    response.close()
    return link

def getUrl(url):
	req = urllib2.Request(url)
	response = urllib2.urlopen(req)
	#print "--sublvl-- response headers"
	#print response.headers['content-type']
	link=response.read()
	response.close()
	return link

def addDirectoryItem(name, parameters={},pic=""):
	xbmcplugin.setContent(handle=int(sys.argv[1]), content="audio" )
	li = xbmcgui.ListItem(name,iconImage="DefaultFolder.png", thumbnailImage=pic)
	li.setProperty('IsPlayable','true')
	li.setInfo(type="music", infoLabels={ "Title": name })
	url = sys.argv[0] + '?' + urllib.urlencode(parameters)
	return xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]), url=url, listitem=li, isFolder=True)

def addPlayableItem(name, url,pic):
	li = xbmcgui.ListItem(name,iconImage=pic, thumbnailImage=pic,path=url)
	li.setInfo( type="Audio", infoLabels={ "Title": name } )
	li.setProperty('IsPlayable', 'true')
	return xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]), url=url, listitem=li, isFolder=False)

def parameters_string_to_dict(parameters):
    ''' Convert parameters encoded in a URL to a dict. '''
    paramDict = {}
    if parameters:
        paramPairs = parameters[1:].split("&")
        for paramsPair in paramPairs:
            paramSplits = paramsPair.split('=')
            if (len(paramSplits)) == 2:
                paramDict[paramSplits[0]] = paramSplits[1]
    return paramDict

# found on http://effbot.org/zone/re-sub.htm#unescape-html
def unescape(text):
    def fixup(m):
        text = m.group(0)
        if text[:2] == "&#":
            # character reference
            try:
                if text[:3] == "&#x":
                    return unichr(int(text[3:-1], 16))
                else:
                    return unichr(int(text[2:-1]))
            except ValueError:
                pass
        else:
            # named entity
            try:
                text = unichr(htmlentitydefs.name2codepoint[text[1:-1]])
            except KeyError:
                pass
        return text # leave as is
    return re.sub("&#?\w+;", fixup, text)
	
def substitute_entity(match):
    ent = match.group(3)
    
    if match.group(1) == "#":
        if match.group(2) == '':
            return unichr(int(ent))
        elif match.group(2) == 'x':
            return unichr(int('0x'+ent, 16))
    else:
        cp = n2cp.get(ent)

        if cp:
            return unichr(cp)
        else:
            return match.group()

def decode_htmlentities(string):
    entity_re = re.compile(r'&(#?)(x?)(\w+);')
    return entity_re.subn(substitute_entity, string)[0]

# ----- main -----

params = parameters_string_to_dict(sys.argv[2])
urlLatest = str(params.get("urlL", ""))
urlPopular = str(params.get("urlP", ""))
urlStream = str(params.get("urlS", ""))

if not sys.argv[2]:
	# new start
	ok = showContent()
else:
	if urlLatest:
		newUrl = urllib.unquote(urlLatest)
		ok = playLatest(newUrl)
	if urlPopular:
		newUrl = urllib.unquote(urlPopular)
		ok = playPopular(newUrl)
	if urlStream:
		newUrl = urllib.unquote(urlStream)
		ok = playStream(newUrl)